<template>
  <div v-if="piece">
    <!-- Renders the piece title into the sidebar -->
    <portal to="sidebar-title">
      <v-tooltip
        v-if="piece.title"
        transition="fade-transition"
        bottom
      >
        <template #activator="{ on, attrs }">
          <span
            v-if="piece"
            class="real-title"
            v-bind="attrs"
            v-on="on"
          >{{ piece.getTitle($i18n.locale) }}</span>
        </template>
        <span>
          <strong>{{ piece.getTitle($i18n.locale) }}</strong>
        </span>
      </v-tooltip>
    </portal>
    <!-- Renders the piece metadata -->
    <portal to="sidebar-metadata-one">
      <span
        v-if="piece.getMetadataOne($i18n.locale)"
      >
        {{ piece.getMetadataOne($i18n.locale) }}
      </span>
      <br v-else>
    </portal>
    <portal to="sidebar-metadata-two">
      <span
        v-if="piece.getMetadataTwo($i18n.locale)"
      >
        {{ piece.getMetadataTwo($i18n.locale) }}
      </span>
      <br v-else>
    </portal>
    <portal to="sidebar-metadata-corpus">
      <a
        v-if="piece.getMetadataCorpus($i18n.locale)"
        tag="span"
        class="link"
        style="cursor:pointer"
        :href="corpusPath"
      >
        {{ piece.getMetadataCorpus($i18n.locale) }}
      </a>
      <br v-else>
    </portal>
    <portal to="sidebar-icons">
      <v-tooltip
        v-if="prev && $store.state.corpusId"
        transition="fade-transition"
        bottom
      >
        <template v-if="prev" #activator="{ on, attrs }">
          <button
            class="change-piece"
            @click="displayPrev"
          >
            <v-icon
              size="big"
              v-bind="attrs"
              v-on="on"
            >
              mdi-skip-previous
            </v-icon>
          </button>
        </template>
        <span id="prev-title">
          <strong>{{ prev.getTitle($i18n.locale) }}</strong>
        </span>
      </v-tooltip>
      <v-icon v-else size="big" class="not-available">
        mdi-skip-previous
      </v-icon>
      <v-menu
        v-if="Object.keys(piece.opus).length > 0"
        right
        close-delay="100"
      >
        <template #activator="{ on, attrs }">
          <v-icon
            size="small" v-bind="attrs"
            @click="showMetadata = !showMetadata"
            v-on="on"
          >
            mdi-information-outline
          </v-icon>
        </template>
        <opus-tooltip :opus="piece.opus" />
      </v-menu>
      <v-icon v-else size="small" class="not-available">
        mdi-information-outline
      </v-icon>
      <v-tooltip
        v-if="next && $store.state.corpusId"
        transition="fade-transition"
        bottom
      >
        <template v-if="next" #activator="{ on, attrs }">
          <button class="change-piece" @click="displayNext">
            <v-icon
              size="big"
              v-bind="attrs"
              v-on="on"
            >
              mdi-skip-next
            </v-icon>
          </button>
        </template>
        <span id="next-title">
          <strong>{{ next.getTitle($i18n.locale) }}</strong>
        </span>
      </v-tooltip>
      <v-icon v-else size="big" class="not-available">
        mdi-skip-next
      </v-icon>
    </portal>
    <portal to="sidebar-refs">
      <ref-links v-if="Object.keys(piece.refs).length > 0" :refs="piece.refs" />
      <br v-else>
    </portal>
  </div>
</template>
<script lang="ts">
import {
  Vue, Component, PropSync, Prop,
} from 'vue-property-decorator';
import OpusTooltip from '@/components/tooltips/OpusTooltip.vue';
import type { Piece } from '@/data';
import { Debounce } from 'vue-debounce-decorator';
import { removeLast } from '@/vuejs/components/utils/nav-tools';
import RefLinks from './RefLinks.vue';
import { warnAnalysisUnsaved } from '../dialogs';

const DEBOUNCE_TIME = 800;

/**
 * Handles sidebar and document title
 */
@Component({
  components: {
    RefLinks,
    OpusTooltip,
  },
})
export default class TitleManager extends Vue {
  @Prop({ default: null })
  appName?: string;

  @PropSync('clean', { default: true, required: false })
  isClean!: boolean;

  corpus!: Piece[];

  indexCurrentPiece!: number;

  prev: Piece | null = null;

  piece: Piece | null = null;

  next: Piece | null = null;

  created() {
    this.init();
  }

  get corpusPath(): string {
    let path = '';
    if (this.piece) path = removeLast(this.piece.path, '/');
    let prefix = '';
    if (this.appName) {
      prefix = `/${this.appName}`;
    }
    return `${prefix}/explore/${path}`;
  }

  init() {
    this.indexCurrentPiece = this.$store.state.indexCurrentPiece;
    if (this.indexCurrentPiece > -1) {
      this.corpus = this.$store.state.corpus;
      this.getPrevNext();
      this.dispatch();
      document.title = `${(this.piece as Piece).getTitle(this.$i18n.locale)} – Dezrann`;
    } else {
      // Otherwise use the default title
      document.title = 'Dezrann';
    }
  }

  getPrevNext() {
    if (this.indexCurrentPiece === 0) this.prev = null;
    else this.prev = this.corpus[this.indexCurrentPiece - 1];

    if (this.indexCurrentPiece >= this.corpus.length - 1) this.next = null;
    else this.next = this.corpus[this.indexCurrentPiece + 1];

    this.piece = this.corpus[this.indexCurrentPiece];
  }

  changePrevNext(add: number) {
    this.indexCurrentPiece += add;
    this.getPrevNext();
  }

  dispatch() {
    this.$store.dispatch('updateIndexCurrentPiece', { indexCurrentPiece: this.indexCurrentPiece });
  }

  @Debounce(DEBOUNCE_TIME)
  goTo(pieceId: string) {
    if (pieceId === this.$route.path.split('/').pop()) return;
    this.$store.dispatch('updateAllowedToPlay', {
      allowedToPlay: false,
    });
    this.$router.push(pieceId);
  }

  async displaySisterPiece(direction: number) {
    if (!this.isClean && await warnAnalysisUnsaved() === false) return;
    this.changePrevNext(direction);
    const pieceId = (this.piece as Piece).path.split('/').pop() as string;
    this.dispatch();
    this.goTo(pieceId);
  }

  async displayPrev() {
    this.displaySisterPiece(-1);
  }

  async displayNext() {
    this.displaySisterPiece(1);
  }

  beforeDestroy() {
    document.title = 'Dezrann';
  }
}
</script>
<style scoped lang="scss">
.not-available {
  color: rgba(255, 255, 255, 0.2);
}
.real-title {
  display: inline-block;
  text-align: right;
  width: 300px;
  overflow: clip;
  text-overflow: ellipsis;
}

.link {
  text-decoration: none;
  color: white;
}
</style>
